#include "vsi-chdcon.malloc.h"

int shem_init(unsigned long size);

void Init_dmy_data(void* data, size_t size);
const int Read_out(Recv_mem & recv_clt, int nrpt);

void Usage(){
  cerr << "Usage: " << me << "[-a <server ip>] [-p <port>] [-f <output file>]"   << endl;
  cerr << "  [-c <channels>] [-s <sample Msps>] [-h]\n";
  cerr << " Receiving VSI2000 data from server and dividing into channels\n" << endl;
  cerr << " Assuming the soruce data is 2 bit for 16 channels.\n" << endl;
  cerr << " -c: Selecting channels(0,1,2...)  default=0 (first)\n";
  cerr << " -h: Show this help" << endl;
  exit(1);
}

// Binding and Listening
int Listener(Socket* sock, int port);
char* me;


int  main(int argc, char *argv[]) {
 /* *** Initialize *** */
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  unsigned short port=7000;
  int mtu=1500;
  string srv_ip("localhost");
  string fname;
  int ich =0;
  unsigned long Msps=2;
  u_int32_t mask_dat=0xc;

  /* * Parse command-line options, if any * */ 
  int k = 0; 
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hp:a:c:s:f:")) { 
    case 'h':   Usage();     break;
    case 'p':   port = atoi(optarg);      break;
    case 'a':   srv_ip = optarg;     break;
    case 'f':   fname  = optarg;     break;
    case 'c':   
      ich = atoi(optarg); 
      if( ich < 0 || ich > 15) Usage();
      else mask_dat = mask[ich];     break;
    case 's':    Msps = atoi(optarg);     break;
    case '?':    Usage(); break;
    }
  }
  
  int status=0;
  Socket *in_sock = new TCPSocket(mtu);
  
  //   if( Listener(in_sock, port) ==0){
  //     fprintf(stderr, "%s Listener Failed.\n", me);
  //     delete in_sock;
  //     exit(1);
  //   }
  // Bind
  char name[80];
  gethostname(name,80);
  if(in_sock->bind(name,0) == -1){
    fprintf(stderr,"%s in_sock->bind(): Error\n",me);
    in_sock->close();
    exit(1);
  }
  Recv_mem recv_clt(*in_sock);
  recv_clt.Set_server(srv_ip); // sps
  recv_clt.Set_sample_dur(Msps*1000000,10); // sps sec
  recv_clt.Set_Srv_port(7000); // sps
  recv_clt.Set_bitmask(mask_dat); 
  recv_clt.Set_RecvBufSize(1024); 

//   if(recv_clt.detach()==0)
//     fprintf(stderr,"recv_clt.detach() success.\n");
//   else
//     fprintf(stderr,"recv_clt.detach() failed.\n");

//  Read_test rt(recv_clt, 10);
//  recv_clt.Set_Reading_thread((Thread*)&rt);
  recv_clt.proc();
  int shm_id=0;
  //  rt.start();
  
  if(Read_out(recv_clt,10)==0)
     fprintf(stderr,"Read_out() success.\n");
   else
     fprintf(stderr,"Read_out() failed.\n");
  
  
//   if(recv_clt.join()==0){
//     fprintf(stderr,"recv_clt.join() success.\n");
//   }else
//     fprintf(stderr,"recv_clt.join() Failed.\n");


  //   char sRecvBuf[256];
  //   while(status != -1){
  //     fprintf(stderr,"Terminate by \"QUIT\" \n");
  //     scanf("%s", sRecvBuf);
  //     StrUpper(sRecvBuf,strlen(sRecvBuf));
  //     if(strncmp(sRecvBuf,"QUIT",4)==0){
  //       break;
  //     }
  //   }
  
  //  recv_clt.Rm_shm();
  
  //  recv_clt.stop();
  //  recv_clt.join();
  delete in_sock;
  //  delete_shm(shm_id);
  
}


void Init_dmy_data(void* data, size_t size){
  wchar_t wc;
  memset(&wc,0xe8,sizeof(wc));
  wmemset((wchar_t*)data,wc,size/sizeof(wc));
}

int Listener(Socket* sock, int port){
  int status;
  
  //  fprintf(stderr,"Binding Socket to %s:%d \n", ip.c_str(), port);
  fprintf(stderr,"Binding Socket to my address:%d \n", port);
  char name[80];
  gethostname(name,80);
  if( sock->bind(name,port) == -1){
    fprintf(stderr,"Error: %s bind failed in Listener()\n", me);
    return 0;
  }
  fprintf(stderr,"Listening to sender socket ...\n");
  if( sock->listen() == -1){
    fprintf(stderr,"Error: %s listen failed in Listener()\n", me);
    return 0;
  }else{
    fprintf(stderr,"Successed\n");
    fprintf(stderr,"%s DEBUG: Waiting for connection with port(%d)\n", me, port);
  }

  return 1;
}


