
//Logger* Logsystem::_dbg_instance=0;

// Logger* Logsystem::Dbg_logger(void){
//   if(_dbg_instance ==0)  _dbg_instance = new Logger;
//   return _dbg_instance;
// }

/* 
 * This software is released under the terms of the MIT License(included below). *  
 * Copyright (c) 2003 MIT Haystack Observatory 
 *  
 * Permission is hereby granted, free of charge, to any person obtaining a   
 * copy of this software and associated documentation files (the "Software"),    * to deal in the Software without restriction, including without limitation   
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,   
 * and/or sell copies of the Software, and to permit persons to whom the  
 * Software is furnished to do so, subject to the following conditions: 
 *  
 * The above copyright notice and this permission notice shall be included in    * all copies or substantial portions of the Software. 
 *   
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER   
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE * SOFTWARE. 
 * 
 */


/* 
 * This software is released under the terms of the MIT License(included below). *  
 * Copyright (c) 2004 MIT Haystack Observatory 
 *  
 * Permission is hereby granted, free of charge, to any person obtaining a   
 * copy of this software and associated documentation files (the "Software"),    * to deal in the Software without restriction, including without limitation   
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,   
 * and/or sell copies of the Software, and to permit persons to whom the  
 * Software is furnished to do so, subject to the following conditions: 
 *  
 * The above copyright notice and this permission notice shall be included in    * all copies or substantial portions of the Software. 
 *   
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER   
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE * SOFTWARE. 
 * 
 */



#include "Logsystem.hpp"

Mutex Logsystem::_mutex;

Logger* Logsystem::_debug_logger_instance=0;
Logger* Logsystem::_info_logger_instance=0;
Logger* Logsystem::_warning_logger_instance=0;
Logger* Logsystem::_error_logger_instance=0;

Logger* Logsystem::debug_logger()
{
  if (_debug_logger_instance==0) {
    _mutex.lock();
    if (_debug_logger_instance==0) {
      _debug_logger_instance=new Logger(_mutex);
    }        
    _mutex.unlock();
  }
  return(_debug_logger_instance);
}

Logger* Logsystem::info_logger()
{
	if (_info_logger_instance==0) {
    	_mutex.lock();
    	if (_info_logger_instance==0) {
        	_info_logger_instance=new Logger(_mutex);
    	}
    	_mutex.unlock();
	}
    return(_info_logger_instance);
}

Logger* Logsystem::warning_logger()
{
	if (_warning_logger_instance==0) {
    	_mutex.lock();
    	if (_warning_logger_instance==0) {
        	_warning_logger_instance=new Logger(_mutex);
    	}
    	_mutex.unlock();    
	}
    return(_warning_logger_instance);}

Logger* Logsystem::error_logger()
{
	if (_error_logger_instance==0) {
    	_mutex.lock();    
    	if (_error_logger_instance==0) {
        	_error_logger_instance=new Logger(_mutex);
    	}
    	_mutex.unlock();
	}
    return(_error_logger_instance);
}


Logsystem::~Logsystem(){
  cerr << "Logsystem Destructor running\n";
  if(_debug_logger_instance !=0){
    delete _debug_logger_instance; _debug_logger_instance=0;}
  if(_info_logger_instance !=0){
    delete _info_logger_instance; _info_logger_instance=0;}
  if(_warning_logger_instance !=0){
    delete _warning_logger_instance; 
    _warning_logger_instance=0;  }
  if(_error_logger_instance !=0){
    delete _error_logger_instance; _error_logger_instance=0;}
}

  
  /** Terminating debug Logger    */
void Logsystem::debug_logger_close(){
  _debug_logger_instance->close_stream();
  if( _debug_logger_instance != 0) delete  _debug_logger_instance;
  _debug_logger_instance =0;
}
/** Terminating info Logger    */
void Logsystem::info_logger_close(){
  _info_logger_instance->close_stream();
  if( _info_logger_instance != 0) delete  _info_logger_instance;
  _info_logger_instance = 0;
}
/** Terminating warinig Logger    */
void Logsystem::warning_logger_close(){
  _warning_logger_instance->close_stream();
  if( _warning_logger_instance != 0) delete  _warning_logger_instance;
  _warning_logger_instance=0;
}
/** Terminating error Logger    */
void Logsystem::error_logger_close(){
  _error_logger_instance->close_stream();
  if( _error_logger_instance != 0) delete  _error_logger_instance;
  _error_logger_instance=0;
}

/** Testing logger availability */
bool Logsystem::Test_Logsys(const LogType_t t, const int level ) {
  
  switch(t){
  case DEBUG: 
    if( _debug_logger_instance ==0 ) return false;
    return ( level <= _debug_logger_instance->Level() &&
	     _debug_logger_instance->Is_Available());
    break;
  case INFO:
    if( _info_logger_instance ==0 ) return false;
    return ( level <= _info_logger_instance->Level() &&
	     _info_logger_instance->Is_Available());
    break;
  case WARNING:
    if( _warning_logger_instance ==0 ) return false;
    return ( level <= _warning_logger_instance->Level() &&
	     _warning_logger_instance->Is_Available());
    break;
  case ERROR:
    if( _error_logger_instance ==0 ) return false;
    return ( level <= _error_logger_instance->Level() &&
	     _error_logger_instance->Is_Available());
    break;
  }

  return false;
}
  

