/*
 *    VRSocket.cpp
 *    vrtp
 *
 *    Created by David Lapsley on Mon Feb 23 2004.
 *    Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */

#include <VRSocket.h>
#include <Utils.h>
#include <unistd.h>
#include <iostream>
#include <errno.h>


VRSocket::VRSocket(Socket& in_sock,
		   Socket& out_sock,
		   RTCPSocket& rtcp_sock,
		   const double& tvg_duration,
		   const u_int32_t& mtu, 
		   const double& rtcp_interval):
  _in_sock(in_sock),
  _out_sock(out_sock),
  _rtcp_sock(rtcp_sock),
  _tvg_duration(tvg_duration),
  _mtu(mtu),
  _rtcp_interval(rtcp_interval),
  _buf(0),
  _active(true)
{
  _buf = new u_int8_t[_mtu];
}

VRSocket::~VRSocket()
{
	 // This is an important feature of the VRSocket class. Especially
	 // for copying of VRSockets. VRSockets do *not* close their
	 // sockets when they are destroyed.
  delete [] _buf;
}

